import React from 'react';
import PropTypes from 'prop-types';
import createUseStyles from "react-jss/dist/react-jss.esm.js";
import clsx from 'clsx';
import HelperText from '../helper-text/helper-text';
var useStyles = createUseStyles({
  root: {
    marginTop: '1em',
    marginBottom: '1em'
  }
});

var FormFieldGrid = function FormFieldGrid(_ref) {
  var className = _ref.className,
      children = _ref.children,
      helperText = _ref.helperText,
      HelperTextProps = _ref.HelperTextProps;
  var classes = useStyles();
  return /*#__PURE__*/React.createElement("div", {
    className: clsx(classes.root, className)
  }, children, helperText && /*#__PURE__*/React.createElement(HelperText, HelperTextProps, helperText));
};

FormFieldGrid.propTypes = {
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]),
  helperText: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]),
  HelperTextProps: PropTypes.object
};
export default FormFieldGrid;