"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormRadio = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/collections/Form/FormRadio.js"));

var _FormField = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/collections/Form/FormField.js"));

var _multipleChoiceList = require("@data-driven-forms/common/multiple-choice-list");

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));

var _helpers = require("../helpers/helpers");

var _useFieldApi3 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var RadioOption = function RadioOption(_ref) {
  var name = _ref.name,
      option = _ref.option,
      isDisabled = _ref.isDisabled,
      isReadOnly = _ref.isReadOnly,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["name", "option", "isDisabled", "isReadOnly"]);

  var _useFieldApi = (0, _useFieldApi3["default"])({
    name: name,
    type: 'radio',
    value: option.value
  }),
      input = _useFieldApi.input;

  return /*#__PURE__*/_react["default"].createElement(_FormRadio["default"], (0, _extends2["default"])({}, input, {
    disabled: isDisabled,
    onChange: function onChange(_event, data) {
      input.onChange({
        target: data,
        type: 'radio'
      });
    }
  }, props, {
    label: option.label
  }));
};

RadioOption.propTypes = {
  name: _propTypes["default"].string.isRequired,
  option: _propTypes["default"].shape({
    label: _propTypes["default"].node.isRequired,
    value: _propTypes["default"].any.isRequired
  }).isRequired,
  isReadOnly: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool
};

var Radio = function Radio(_ref2) {
  var name = _ref2.name,
      props = (0, _objectWithoutProperties2["default"])(_ref2, ["name"]);

  var _useFieldApi2 = (0, _useFieldApi3["default"])(_objectSpread(_objectSpread({}, props), {}, {
    name: name,
    type: 'radio'
  })),
      options = _useFieldApi2.options,
      isDisabled = _useFieldApi2.isDisabled,
      label = _useFieldApi2.label,
      isRequired = _useFieldApi2.isRequired,
      helperText = _useFieldApi2.helperText,
      description = _useFieldApi2.description,
      isReadOnly = _useFieldApi2.isReadOnly,
      meta = _useFieldApi2.meta,
      validateOnMount = _useFieldApi2.validateOnMount,
      FormFieldGridProps = _useFieldApi2.FormFieldGridProps,
      FormFieldProps = _useFieldApi2.FormFieldProps,
      HelperTextProps = _useFieldApi2.HelperTextProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi2, ["options", "isDisabled", "label", "isRequired", "helperText", "description", "isReadOnly", "meta", "validateOnMount", "FormFieldGridProps", "FormFieldProps", "HelperTextProps"]);

  var invalid = (0, _helpers.validationError)(meta, validateOnMount);
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], (0, _extends2["default"])({
    helperText: (0, _helpers.validationWarning)(meta, validateOnMount) || helperText,
    HelperTextProps: HelperTextProps
  }, FormFieldGridProps), /*#__PURE__*/_react["default"].createElement(_FormField["default"], (0, _extends2["default"])({}, FormFieldProps, {
    disabled: isDisabled,
    required: isRequired,
    error: invalid && {
      content: meta.error || meta.submitError
    },
    label: label
  })), options.map(function (option) {
    return /*#__PURE__*/_react["default"].createElement(RadioOption, (0, _extends2["default"])({
      key: option.value,
      name: name,
      option: option,
      isDisabled: isDisabled,
      isReadOnly: isReadOnly
    }, rest));
  }));
};

Radio.propTypes = _objectSpread(_objectSpread({}, _multipleChoiceList.wrapperProps), {}, {
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    value: _propTypes["default"].any,
    label: _propTypes["default"].node
  })),
  label: _propTypes["default"].node.isRequired,
  isDisabled: _propTypes["default"].bool,
  children: _propTypes["default"].any,
  description: _propTypes["default"].node,

  /** Sub components customization API */
  FormFieldGridProps: _propTypes["default"].object,
  FormFieldProps: _propTypes["default"].object,
  HelperTextProps: _propTypes["default"].object
});
Radio.defaultProps = {
  options: [],
  FormFieldGridProps: {},
  FormFieldProps: {},
  HelperTextProps: {}
};
var _default = Radio;
exports["default"] = _default;