"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InternalSelect = exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _select = _interopRequireDefault(require("@data-driven-forms/common/select"));

var _parseInternalValue = _interopRequireDefault(require("@data-driven-forms/common/select/parse-internal-value"));

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));

var _helpers = require("../helpers/helpers");

var _propTypesTemplates = require("@data-driven-forms/common/prop-types-templates");

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _Dropdown = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/modules/Dropdown/Dropdown.js"));

var _formField = _interopRequireDefault(require("../form-field/form-field"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var SuirSelect = function SuirSelect(_ref) {
  var _onChange = _ref.onChange,
      value = _ref.value,
      meta = _ref.meta,
      helperText = _ref.helperText,
      validateOnMount = _ref.validateOnMount,
      isReadOnly = _ref.isReadOnly,
      isDisabled = _ref.isDisabled,
      isClearable = _ref.isClearable,
      isSearchable = _ref.isSearchable,
      options = _ref.options,
      label = _ref.label,
      isMulti = _ref.isMulti,
      isRequired = _ref.isRequired,
      classNamePrefix = _ref.classNamePrefix,
      onInputChange = _ref.onInputChange,
      isFetching = _ref.isFetching,
      noOptionsMessage = _ref.noOptionsMessage,
      hideSelectedOptions = _ref.hideSelectedOptions,
      closeMenuOnSelect = _ref.closeMenuOnSelect,
      FormFieldGridProps = _ref.FormFieldGridProps,
      HelpertextProps = _ref.HelpertextProps,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["onChange", "value", "meta", "helperText", "validateOnMount", "isReadOnly", "isDisabled", "isClearable", "isSearchable", "options", "label", "isMulti", "isRequired", "classNamePrefix", "onInputChange", "isFetching", "noOptionsMessage", "hideSelectedOptions", "closeMenuOnSelect", "FormFieldGridProps", "HelpertextProps"]);
  var invalid = (0, _helpers.validationError)(meta, validateOnMount);
  var internalValue = (0, _parseInternalValue["default"])(value, isMulti);
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], (0, _extends2["default"])({
    helperText: (0, _helpers.validationWarning)(meta, validateOnMount) || helperText,
    HelpertextProps: HelpertextProps
  }, FormFieldGridProps), /*#__PURE__*/_react["default"].createElement(_formField["default"], (0, _extends2["default"])({
    disabled: isDisabled,
    readOnly: isReadOnly,
    required: isRequired,
    clearable: isClearable,
    search: isSearchable,
    loading: isFetching,
    noResultsMessage: isFetching ? 'Loading' : noOptionsMessage(),
    onSearchChange: function onSearchChange(_ref2) {
      var value = _ref2.target.value;
      return onInputChange(value);
    },
    options: options.map(function (_ref3) {
      var label = _ref3.label,
          value = _ref3.value,
          rest = (0, _objectWithoutProperties2["default"])(_ref3, ["label", "value"]);
      return _objectSpread({
        key: value,
        text: label,
        value: value
      }, rest);
    }),
    onChange: function onChange(_event, _ref4) {
      var value = _ref4.value;

      if (isMulti) {
        return _onChange(Array.isArray(value) && value.map(function (value) {
          return {
            value: value
          };
        }));
      }

      return _onChange(value && {
        value: value
      });
    },
    selection: true,
    fluid: true,
    multiple: isMulti,
    label: label,
    error: invalid && {
      content: meta.error || meta.submitError
    },
    control: _Dropdown["default"],
    value: internalValue
  }, rest)));
};

SuirSelect.propTypes = {
  input: _propTypesTemplates.input,
  meta: _propTypesTemplates.meta,
  placeholder: _propTypes["default"].node,
  label: _propTypes["default"].node,
  helperText: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  isSearchable: _propTypes["default"].bool,
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    value: _propTypes["default"].any.isRequired,
    label: _propTypes["default"].node.isRequired
  })),
  description: _propTypes["default"].node,
  isReadOnly: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  onChange: _propTypes["default"].func.isRequired,
  value: _propTypes["default"].any,
  isMulti: _propTypes["default"].bool,
  isClearable: _propTypes["default"].bool,
  noOptionsMessage: _propTypes["default"].func,
  isRequired: _propTypes["default"].bool,
  classNamePrefix: _propTypes["default"].string,
  onInputChange: _propTypes["default"].func,
  isFetching: _propTypes["default"].bool,
  hideSelectedOptions: _propTypes["default"].bool,
  closeMenuOnSelect: _propTypes["default"].bool,

  /** Sub components customization API */
  FormFieldGridProps: _propTypes["default"].object,
  HelpertextProps: _propTypes["default"].object
};
SuirSelect.defaultProps = {
  placeholder: 'Please choose',
  noOptionsMessage: 'No option found',
  options: [],
  FormFieldGridProps: {},
  HelpertextProps: {}
};

var Select = function Select(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      input = _useFieldApi.input,
      formProps = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["input"]);

  return /*#__PURE__*/_react["default"].createElement(_select["default"], (0, _extends2["default"])({
    simpleValue: true
  }, input, formProps, {
    SelectComponent: SuirSelect
  }));
};

var _default = Select;
exports["default"] = _default;
var InternalSelect = SuirSelect;
exports.InternalSelect = InternalSelect;