"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormTextArea = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/collections/Form/FormTextArea.js"));

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));

var _helpers = require("../helpers/helpers");

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _formField = _interopRequireDefault(require("../form-field/form-field"));

var Textarea = function Textarea(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      placeholder = _useFieldApi.placeholder,
      isRequired = _useFieldApi.isRequired,
      helperText = _useFieldApi.helperText,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      FormFieldGridProps = _useFieldApi.FormFieldGridProps,
      HelpertextProps = _useFieldApi.HelpertextProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["input", "isReadOnly", "isDisabled", "placeholder", "isRequired", "helperText", "validateOnMount", "meta", "FormFieldGridProps", "HelpertextProps"]);

  var invalid = (0, _helpers.validationError)(meta, validateOnMount);
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], (0, _extends2["default"])({
    helperText: (0, _helpers.validationWarning)(meta, validateOnMount) || helperText,
    HelpertextProps: HelpertextProps
  }, FormFieldGridProps), /*#__PURE__*/_react["default"].createElement(_formField["default"], (0, _extends2["default"])({
    required: isRequired,
    disabled: isDisabled,
    readOnly: isReadOnly
  }, input, {
    error: invalid && {
      content: meta.error || meta.submitError
    },
    control: _FormTextArea["default"]
  }, rest)));
};

Textarea.propTypes = {
  isReadOnly: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  placeholder: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  helperText: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  description: _propTypes["default"].node,

  /** Sub components customization API */
  FormFieldGridProps: _propTypes["default"].object,
  HelpertextProps: _propTypes["default"].object
};
Textarea.defaultProps = {
  FormFieldGridProps: {},
  HelpertextProps: {}
};
var _default = Textarea;
exports["default"] = _default;